--------------------------------------------------------------------------------------------------------------------------------------

	-- Fonctions secondaires --

----------------------------------------------------------------------------------------------------------------------------------------



--------------- ! Fonction qui intialise les variables du dmarrage ! ---------------
function initialiser_variables()
	-- ! Images ! --
	-- Le Heros Tinw
	img_tinwe = Image.load("images/persos/tinwe.png")
	
	
	-- Les elements de la map
	sprite_map = Image.load("images/map/sprite_map.png") 
	cadre_map = Image.load("images/autres/cadre_info.png")
	masque_pause = Image.load("images/autres/fond_pause.png")
	decouper_map()
	
	-- Images pour les evenements
	img_events = {}
	img_events[1] = Image.load("images/map/depart.png")
	img_events[2] = Image.load("images/map/arrivee.png")
	img_events[3] = Image.load("images/map/teleport.png")
	
	
	
	-- La lueur de Tinw
	halo_tinwe = Image.load("images/autres/halo.png")
	
	
	-- ! Variables (Int) ! --
	id_map = 1 -- Indice de la map en cours
	id_img_tinwe = 1 -- Indice pour l'affichage du sprite de Tinw
	id_move_tinwe = 1 -- Indice pour le dplacement de Tinw
	
	x_tinwe = 0 -- Position en X de Tinw
	y_tinwe = 0 -- Position en Y de Tinw
	
	x_map = 0 -- Position en X de la map
	y_map = 0 -- Position en Y de la map
	
	colonne = 1 -- Indice pour savoir sur quelle colonne se trouve Tinw
	ligne = 1 -- Indice pour savoir sur quelle ligne se trouve Tinw
	
	
	-- ! Variables (Bool) ! --
	rafraichir = true -- Permet d'actualiser l'cran quand "vrai"
	fin_du_jeu = false -- Permet de quitter le jeu
	chrono = Timer.new()
	touche = Timer.new()
	touche:stop()
	touche:reset()
	touche:start()
	mem_temps = 0
	IntraFont.load("flash0:/font/ltn12.pgf", 1)
end

--------------- ! Fonction qui charge les variables pour le niveau ! ---------------
function charger_var_niveau()
	-- Variable de positionnement
	colonne = events[1].col
	ligne = events[1].lig
	meilleur_temps = math.ceil((all_maps[id_map].tps)/1000)*1000
	record = all_maps[id_map].rec
	medaille = {gold = meilleur_temps + (meilleur_temps*0.1); silver = meilleur_temps + (meilleur_temps*0.3); bronze = meilleur_temps + (meilleur_temps*0.9)}
	medaille_convert = {gold = mise_en_forme_chrono(medaille.gold); silver = mise_en_forme_chrono(medaille.silver); bronze = mise_en_forme_chrono(medaille.bronze)}

	positionner_tinwe()
end

--------------- ! Fonction qui permet de positionner Tinw (demarrage, teleport...) ! ---------------
function positionner_tinwe()
	-- ! Si la map est plus grande que l'cran en largeur ! --
	 if (all_maps[id_map].c > 15) then
		if (colonne < 8) then
			x_tinwe = ((colonne - 1)*32)
			x_map = x_tinwe
		elseif (all_maps[id_map].c - colonne <= 6) then
			x_tinwe = 416 - ((all_maps[id_map].c - colonne - 1)*32)
			x_map = x_tinwe
		else
			x_tinwe = 224
			x_map = x_tinwe
		end
	else
		x_tinwe = ((colonne - 1)*32)
		x_map = x_tinwe
	end
	
	-- ! Si la map est plus grande que l'cran en hauteur ! --
	if (all_maps[id_map].l > 9) then
		if (ligne < 5) then
			y_tinwe = ((ligne - 1)*32)
			y_map = y_tinwe
		elseif (all_maps[id_map].l - ligne <= 4) then
			y_tinwe = 192 - ((all_maps[id_map].l - ligne - 1)*32)
			y_map = y_tinwe
		else
			y_tinwe = 96
			y_map = y_tinwe
		end
	else
		y_tinwe = ((ligne - 1)*32)
		y_map = y_tinwe
	end
end

--------------- ! Fonction qui dcoupe la planche de sprites (hros) ! ---------------
function decouper_tinwe()
	-- ! On cre un tableau ! --
	cut_tinwe = {}
	-- ! Pour chaque entre on a les coordonnes de la portion d'image ! -- 
	cut_tinwe[1] = {x = 0 ; y = 0}
	cut_tinwe[2] = {x = 32 ; y = 0}
	cut_tinwe[3] = {x = 64 ; y = 0}
	cut_tinwe[4] = {x = 96 ; y = 0}
	cut_tinwe[5] = {x = 128 ; y = 0}
	cut_tinwe[6] = {x = 160 ; y = 0}
	cut_tinwe[7] = {x = 192 ; y = 0}
	cut_tinwe[8] = {x = 224 ; y = 0}
end

--------------- ! Fonction qui dcoupe la planche de sprites (map) ! ---------------
function decouper_map()
	-- ! On cre un tableau ! --
	cut_map = {}
	-- ! Pour chaque entre on a les coordonnes de la portion d'image ! -- 
	cut_map[1] = {x = 0 ; y = 0}
	cut_map[2] = {x = 32 ; y = 0}
	cut_map[3] = {x = 64 ; y = 0}
	cut_map[4] = {x = 96 ; y = 0}
	cut_map[5] = {x = 128 ; y = 0}	
	cut_map[6] = {x = 0 ; y = 32}
	cut_map[7] = {x = 32 ; y = 32}
	cut_map[8] = {x = 64 ; y = 32}
	cut_map[9] = {x = 96 ; y = 32}
	cut_map[10] = {x = 128 ; y = 32}
	cut_map[11] = {x = 0 ; y = 64}
	cut_map[12] = {x = 32 ; y = 64}
	cut_map[13] = {x = 64 ; y = 64}
	cut_map[14] = {x = 96 ; y = 64}
	cut_map[15] = {x = 128 ; y = 64}	
	
end

--------------- ! Fonction qui selectionne les evenements de la map en cours ! ---------------
function tri_events()
	events = {}
	nb_events = 0
	for i = 1, table.getn(all_events) do
		if (all_events[i].id == id_map) then
			nb_events = nb_events + 1
			events[nb_events] = all_events[i]
		end
	end
end

--------------- ! Fonction qui cre la map du niveau en cours ! ---------------
function decoupe_niveau()
	-- ! On cre le tableau qui contient les infos du niveau en cours ! --
	tab_map = {}
	tab_passage = {}
	
	for i = 1,all_maps[id_map].l*all_maps[id_map].c do
		tab_map[i] = (string.sub(all_maps[id_map].carte,i,i))
		if (tab_map[i] == "a") then
			tab_map[i] = 10
		elseif (tab_map[i] == "b") then
			tab_map[i] = 11
		elseif (tab_map[i] == "c") then
			tab_map[i] = 12
		elseif (tab_map[i] == "d") then
			tab_map[i] = 13
		elseif (tab_map[i] == "e") then
			tab_map[i] = 14
		elseif (tab_map[i] == "f") then
			tab_map[i] = 15
		end
		tab_map[i] = tonumber(tab_map[i])
		tab_passage[i] = false
	end
end

--------------- ! Fonction qui concoit le tableau contenant la carte pour l'apercu ! ---------------
function concevoir_carte()
	
	-- ! On calcule l'unit de proportion ! --
	if (math.floor(440/(all_maps[id_map].c - 2)) < math.floor(252/(all_maps[id_map].l - 2))) then
		unite_carte = math.floor(440/(all_maps[id_map].c - 2))
		x_carte = 20
		y_carte = 20
	else
		unite_carte = math.floor(252/(all_maps[id_map].l - 2))
		x_carte = 20
		y_carte = (272 - (all_maps[id_map].l - 2)*unite_carte)/2
	end
	mi_case = (unite_carte/2 - 1)
	
	
	tab_carte = {}
	tab_couleur = {}
	for j = 1,all_maps[id_map].l do
		for i = 1, all_maps[id_map].c do
			if ((j > 1) and (j < all_maps[id_map].l) and (i > 1) and (i < all_maps[id_map].c)) then
				if tab_passage[((j-1)*all_maps[id_map].c)+i] == false then
					tab_carte[table.getn(tab_carte) + 1] = 0
				else
					if tab_map[((j-1)*all_maps[id_map].c)+i] ~= 0 then
						tab_carte[table.getn(tab_carte) + 1] = tab_map[((j-1)*all_maps[id_map].c)+i]
					else
						tab_carte[table.getn(tab_carte) + 1] = 0
					end
				end
			end
			tab_couleur[table.getn(tab_carte)] = Color.new(0,120,230)
			for k = 1,table.getn(events) do
				if ((j == events[k].lig) and (i == events[k].col))then
					tab_couleur[table.getn(tab_carte)] = events[k].couleur
				end
			end
			
			if (j == ligne) and (colonne == i) then
				id_cale = table.getn(tab_carte)
			end
		end
	end
end

--------------- ! Fonction pour palier la sensibilit des touches ! ---------------
function delai(temps)
	timer = Timer.new()
	while (timer:time() < temps) do -- boucle pour palier la sensibilit des touches
		timer:start()
	end
	timer:reset(0)
end

--------------- ! Fonction lors d'un changement de niveau ! ---------------
function changement_niveau()
	chrono:stop()
	temps_niveau = math.floor(chrono:time()/100)*100
	if (temps_niveau < record) or (record == 0) then
		new_record = true
		all_maps[id_map].rec = temps_niveau
	else
		new_record = false
	end
	-- Images pour les mdailles
	img_change_niveau = Image.load("images/autres/changement_niveau.png")
	img_medaille = {}
	img_medaille[1] = Image.load("images/autres/gold.png")
	img_medaille[2] = Image.load("images/autres/silver.png")
	img_medaille[3] = Image.load("images/autres/bronze.png")
	img_medaille[4] = Image.load("images/autres/none.png")
	
	attribution_medaille = {}
	if (temps_niveau <= medaille.gold) then
		attribution_medaille = {lib = "Mdaille d'Or" ; pos_x = 175 ; couleur = IntraFont.color(255,215,0,255) ; ombre = IntraFont.color(0,0,0,255) ; img = 1}
	elseif (temps_niveau <= medaille.silver) then
		attribution_medaille = {lib = "Mdaille d'Argent" ; pos_x = 153 ; couleur = IntraFont.color(206,206,206,255) ; ombre = IntraFont.color(0,0,0,255) ; img = 2}
	elseif (temps_niveau <= medaille.bronze) then
		attribution_medaille = {lib = "Mdaille de Bronze" ; pos_x = 145 ; couleur = IntraFont.color(97,78,26,255) ; ombre = IntraFont.color(255,255,255,255) ; img = 3}
	else
		attribution_medaille = {lib = "Aucune mdaille" ; pos_x = 157 ; couleur = IntraFont.color(255,255,255,255) ; ombre = IntraFont.color(0,0,0,255) ; img = 4}
	end
	all_maps[id_map].med = attribution_medaille.img + 1
	temps_niveau = math.floor(temps_niveau*10)/10
	temps_total = mise_en_forme_chrono(temps_niveau)
	masque = Image.createEmpty(480,272)
	opacite = 0
	masque:clear(Color.new(255,255,255,opacite))
	
	IntraFont.load("flash0:/font/ltn4.pgf", 1)
	while (opacite < 255) do
		screen:clear(Color.new(170,215,255))
		actualiser_ecran(2)
		screen:blit(0,0,masque)
		Gu.start3d()
		IntraFont.print((240 - ((IntraFont.print(240,130,"Niveau Termin",1,0,0) - 240)/2)),140,"Niveau Termin", 1, IntraFont.color(255,0,0,255), IntraFont.color(200,200,200,opacite))
		Gu.end3d()
		screen.waitVblankStart()
		screen:flip()
		opacite = opacite + 5
		masque:clear(Color.new(255,255,255,opacite))
	end
	masque,opacite = nil
	screen.waitVblankStart(100)
	
	oldpad = Controls.read()
	fin_changement = 0
	rafraichir = true
	selecteur = 1
	while (fin_changement == 0) do
		pad = Controls.read()
		if (rafraichir == true) then
			rafraichir = false
			screen:blit(0,0,img_change_niveau)
			screen:blit(110,-15,img_medaille[attribution_medaille.img])
			Gu.start3d()
			IntraFont.load("flash0:/font/ltn12.pgf", 1)
			IntraFont.print(10,20,"Meilleur temps : "..mise_en_forme_chrono(all_maps[id_map].rec),1,IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
			IntraFont.print(390,20,"Niveau : "..id_map,1,IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
			IntraFont.print(10,180,"Or : "..medaille_convert.gold,1,IntraFont.color(255,215,0,255),IntraFont.color(0,0,0,255))
			IntraFont.print(10,200,"Argent : "..medaille_convert.silver,1,IntraFont.color(206,206,206,255),IntraFont.color(0,0,0,255))
			IntraFont.print(10,220,"Bronze : "..medaille_convert.bronze,1,IntraFont.color(97,78,26,255),IntraFont.color(0,0,0,255))
			if (new_record == true) then
				IntraFont.print(50,38,"Nouveau Record!",1,IntraFont.color(255,0,0,255),IntraFont.color(255,255,255,255))
			end
			IntraFont.load("flash0:/font/ltn4.pgf", 1)
			IntraFont.print(attribution_medaille.pos_x,110,attribution_medaille.lib,1,attribution_medaille.couleur,attribution_medaille.ombre)
			IntraFont.load("flash0:/font/ltn5.pgf", 1)
			IntraFont.print((240 - ((IntraFont.print(240,260,"Temps :",1,0,0) - 240)/2)),150,"Temps:", 1, attribution_medaille.couleur,attribution_medaille.ombre)
			IntraFont.load("flash0:/font/ltn4.pgf", 1)
			IntraFont.print((240 - ((IntraFont.print(240,260,temps_total,1,0,0) - 240)/2)),180,temps_total, 1, attribution_medaille.couleur,attribution_medaille.ombre)
				
			if (selecteur == 1) then
				IntraFont.load("flash0:/font/ltn5.pgf", 1)
				IntraFont.print(20,260,"Continuer",1,IntraFont.color(255,255,255,255),IntraFont.color(255,0,0,255))
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,260,"Ressayer",1,0,0) - 240)/2)),260,"Ressayer", 1, IntraFont.color(150,150,150,255),IntraFont.color(50,50,50,255))
				IntraFont.print((460 - (IntraFont.print(0,200,"Quitter",1,0,0))),260,"Quitter",1,IntraFont.color(150,150,150,255),IntraFont.color(50,50,50,255))
			elseif (selecteur == 2) then
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print(20,260,"Continuer",1,IntraFont.color(150,150,150,255),IntraFont.color(50,50,50,255))
				IntraFont.load("flash0:/font/ltn5.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,260,"Ressayer",1,0,0) - 240)/2)),260,"Ressayer", 1, IntraFont.color(255,255,255,255),IntraFont.color(255,0,0,255))
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print((460 - (IntraFont.print(0,200,"Quitter",1,0,0))),260,"Quitter",1,IntraFont.color(150,150,150,255),IntraFont.color(50,50,50,255))
			else
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print(20,260,"Continuer",1,IntraFont.color(150,150,150,255),IntraFont.color(50,50,50,255))
				IntraFont.print((240 - ((IntraFont.print(240,260,"Ressayer",1,0,0) - 240)/2)),260,"Ressayer", 1, IntraFont.color(150,150,150,255),IntraFont.color(50,50,50,255))
				IntraFont.load("flash0:/font/ltn5.pgf", 1)
				IntraFont.print((460 - (IntraFont.print(0,200,"Quitter",1,0,0))),260,"Quitter",1,IntraFont.color(255,255,255,255),IntraFont.color(255,0,0,255))
			end
			Gu.end3d()
			
			screen.waitVblankStart()
			screen:flip()
		end
		
		if (pad:right() and not oldpad:right()) then
			if (selecteur == 3) then
				selecteur = 1
			else
				selecteur = selecteur + 1
			end
			rafraichir = true
		elseif (pad:left() and not oldpad:left()) then
			if (selecteur == 1) then
				selecteur = 3
			else
				selecteur = selecteur - 1
			end
			rafraichir = true
		elseif (pad:cross() and not oldpad:cross()) then
			fin_changement = selecteur
		end
		oldpad = pad
	end
	if (new_record == true) then
		sauvegarder_partie(type_partie)
	end
	img_change_niveau = nil
	img_medaille = nil
	if (fin_changement == 1) then
		if (id_map + 1 > table.getn(all_maps)) then
			fin_du_jeu = true
			 game_over()
		else
			id_map = id_map + 1
		end
	elseif (fin_changement == 3) then
		fin_du_jeu = true
		creer_maps(type_partie)
		creer_events(type_partie)
		menu_niveau()
		jeu()
	end
	if (fin_du_jeu == false) then
		decoupe_niveau()
		
		-- ! On trie les evenements ! --
		tri_events()
		
		-- ! On charge les variables du niveau ! --
		charger_var_niveau()
		
		mem_temps = 0
		IntraFont.load("flash0:/font/ltn12.pgf", 1)
		compte_a_rebours()
	else
		chrono:stop()
		chrono:reset(0)
		
	end
end

--------------- ! Fonction qui met en forme un temps ! ---------------
function mise_en_forme_chrono(temp)
	minutes = math.floor(temp/60000)
	seconde = math.floor(math.mod(temp,60000)/1000)
	millsec = string.sub(math.mod(math.mod(temp,60000),1000),1,1)
	if (minutes > 0) then
		return(tostring(minutes.."\'"..seconde.."\'\'"..millsec))
	else
		return(tostring(seconde.."\'\'"..millsec))
	end
end

--------------- ! Fonction du compte  rebours avant le lancement du niveau ! ---------------
function compte_a_rebours()
	masque_compteur = Image.load("images/autres/flou_compteur.png")
	compteur_rebours = Timer.new()
	compteur_rebours:stop()
	compteur_rebours:reset()
	compteur_rebours:start()
	message_compteur = {"Prt?","3","2","1","Partez"}
	for i = 1,5 do
		rafraichir = true
		while (compteur_rebours:time() < 1000) do
			if (rafraichir == true) then
				rafraichir = false
				screen:clear(Color.new(170,215,255))
				IntraFont.load("flash0:/font/ltn12.pgf", 1)
				actualiser_ecran(1)
				screen:blit(0,0,masque_compteur)
				IntraFont.load("flash0:/font/ltn4.pgf", 1)
				Gu.start3d()
				IntraFont.print((240 - ((IntraFont.print(240,130,message_compteur[i],1,0,0) - 240)/2)),140,message_compteur[i], 1, IntraFont.color(255,0,0,255), IntraFont.color(200,200,200,255))
				Gu.end3d()
				screen.waitVblankStart()
				screen:flip()
			end
		end
		compteur_rebours:stop()
		compteur_rebours:reset()
		compteur_rebours:start()
	end
	masque_compteur = nil
	chrono:stop()
	chrono:reset(0)
	chrono:start()
	
	IntraFont.load("flash0:/font/ltn12.pgf", 1)
end

--------------- ! Fonction qui selectionne les maps selectionnables  l'cran du choix de niveau ! ---------------
function selection_niveau(ind)
	tab_sel = {}
	debut_sel = (ind - 1)*15 + 1
	if (ind*15 > table.getn(all_maps)) then
		fin_sel = table.getn(all_maps)
		derniere_page = true
	else
		fin_sel = ind*15
		derniere_page = false
	end
	
	for i = debut_sel,fin_sel do
		if (all_maps[i].rec ~= 0)then
			tab_sel[table.getn(tab_sel)+1] = {num = all_maps[i].num ; parcouru = true ; medaille = all_maps[i].med}
		else
			tab_sel[table.getn(tab_sel)+1] = {num = all_maps[i].num ; parcouru = false ; medaille = all_maps[i].med}
		end
	end
end

--------------- ! Fonction qui affiche une aide ! ---------------
function afficher_aide(var)
	bg_aide = Image.load("images/autres/changement_niveau.png")
	rafraichir = true
	oldpad = Controls.read()
	fin_aide = false
	while fin_aide == false do
		pad = Controls.read()
		if (rafraichir == true) then
			screen:blit(0,0,bg_aide)
			Gu.start3d()
			IntraFont.load("flash0:/font/ltn4.pgf", 1)
			IntraFont.print(20,25,"Aide : \" ", 1, IntraFont.color(255,255,0,255),IntraFont.color(0,0,0,255))
			if (var == 1) then -- Menu Principal
				IntraFont.print((IntraFont.print(20,0,"Aide : \" ", 1,0,0)),25,"Menu Principal ", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))				
				IntraFont.print((IntraFont.print(20,0,"Aide : \" Menu Principal ", 1,0,0)),25,"\"", 1, IntraFont.color(255,255,0,255),IntraFont.color(0,0,0,255))				
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print(20,50,"Arcade : ", 1, IntraFont.color(255,0,0,255) ,IntraFont.color(0,0,0,255))
				IntraFont.print(IntraFont.print(20,50,"Arcade : ", 1, 0,0),50,"Parcourez les labyrinthes officiels.", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(20,70,"Partie Personnalise : ", 1, IntraFont.color(255,0,0,255) ,IntraFont.color(0,0,0,255))
				IntraFont.print(IntraFont.print(20,70,"Partie Personnalise : ", 1,0,0),70,"Rsolvez vos propres cartes.", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(20,90,"Options : ", 1, IntraFont.color(255,0,0,255),IntraFont.color(0,0,0,255))
				IntraFont.print(IntraFont.print(20,90,"Options : ", 1, 0,0),90,"Rinitialisez vos records.", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(20,110,"Cl [Editor] : ", 1, IntraFont.color(255,0,0,255),IntraFont.color(0,0,0,255))
				IntraFont.print(IntraFont.print(20,110,"Cl [Editor] : ", 1,0,0),110,"Lancez le crateur de cartes.", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(20,210,"Haut/Bas : ", 1, IntraFont.color(50,0,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(IntraFont.print(20,210,"Haut/Bas : ", 1,0,0),210,"Dplacez la selection", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(20,230,"Croix : ", 1, IntraFont.color(50,0,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(IntraFont.print(20,230,"Croix : ", 1,0,0),230,"Valider", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
			elseif (var == 2) then
				IntraFont.print((IntraFont.print(20,0,"Aide : \" ", 1,0,0)),25,"Options ", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))				
				IntraFont.print((IntraFont.print(20,0,"Aide : \" Options ", 1,0,0)),25,"\"", 1, IntraFont.color(255,255,0,255),IntraFont.color(0,0,0,255))				
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print(20,50,"Rinitialiser Arcade : ", 1, IntraFont.color(255,0,0,255),IntraFont.color(0,0,0,255))
				IntraFont.print(IntraFont.print(20,50,"Rinitialiser Arcade : ", 1,0,0),50,"Effacer tous vos records du mode Arcade.", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(20,70,"Rinitialiser Partie Personnalise : ", 1, IntraFont.color(255,0,0,255),IntraFont.color(0,0,0,255))
				IntraFont.print(IntraFont.print(20,70,"Rinitialiser Partie Personnalise : ", 1,0,0),70,"REffacer tous vos records.", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(20,90,"Crdits : ", 1, IntraFont.color(255,0,0,255),IntraFont.color(0,0,0,255))
				IntraFont.print(IntraFont.print(20,90,"Crdits : ", 1, 0,0),90,"Jetez un coup d'oeil aux crdits.", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(20,190,"Haut/Bas : ", 1, IntraFont.color(50,0,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(IntraFont.print(20,190,"Haut/Bas : ", 1,0,0),190,"Dplacez la selection", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(20,210,"Croix : ", 1, IntraFont.color(50,0,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(IntraFont.print(20,210,"Croix : ",1,0,0),210,"Valider", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(20,230,"Rond : ", 1, IntraFont.color(50,0,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(IntraFont.print(20,230,"Rond : ", 1,0,0),230,"Retour au menu principal", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
			elseif (var == 3) or (var == 4) then
				if (var == 3) then
					IntraFont.print((IntraFont.print(20,0,"Aide : \" ", 1,0,0)),25,"Arcade ", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))				
					IntraFont.print((IntraFont.print(20,0,"Aide : \" Arcade ", 1,0,0)),25,"\"", 1, IntraFont.color(255,255,0,255),IntraFont.color(0,0,0,255))				
				else
					IntraFont.print((IntraFont.print(20,0,"Aide : \" ", 1,0,0)),25,"Partie Perso ", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))				
					IntraFont.print((IntraFont.print(20,0,"Aide : \" Partie Perso ", 1,0,0)),25,"\"", 1, IntraFont.color(255,255,0,255),IntraFont.color(0,0,0,255))				
				end
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print(20,50,"Flches : ", 1, IntraFont.color(50,0,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(IntraFont.print(20,190,"Flches : ", 1,0,0),50,"Dplacer le curseur de slection.", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(20,70,"L/R : ", 1, IntraFont.color(50,0,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(IntraFont.print(20,70,"L/R : ", 1,0,0),70,"Changer de page (si possible)", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(20,90,"Croix : ", 1, IntraFont.color(50,0,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(IntraFont.print(20,90,"Croix : ", 1,0,0),90,"Lancer le niveau (si possible)", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(20,110,"Rond : ", 1, IntraFont.color(50,0,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(IntraFont.print(20,110,"Rond : ", 1,0,0),110,"Retour au menu principal", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))
			elseif (var == 5) then
				IntraFont.print((IntraFont.print(20,0,"Aide : \" ", 1,0,0)),25,"Jeu ", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))				
				IntraFont.print((IntraFont.print(20,0,"Aide : \" Jeu ", 1,0,0)),25,"\"", 1, IntraFont.color(255,255,0,255),IntraFont.color(0,0,0,255))	
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print(20,50,"Flches : ", 1, IntraFont.color(50,0,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(IntraFont.print(20,190,"Flches : ", 1,0,0),50,"Se dplacer", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))	
				IntraFont.print(20,70,"Triangle : ", 1, IntraFont.color(50,0,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(IntraFont.print(20,190,"Triangle : ", 1,0,0),70,"Afficher ce que l'on a parcouru", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))			
				IntraFont.print(20,90,"Start : ", 1, IntraFont.color(50,0,255,255),IntraFont.color(0,0,0,255))
				IntraFont.print(IntraFont.print(20,190,"Start : ", 1,0,0),90,"Mettre en pause", 1, IntraFont.color(255,255,255,255),IntraFont.color(0,0,0,255))			
			end
		
			IntraFont.load("flash0:/font/ltn5.pgf", 1)
			IntraFont.print(20,260,"Rond pour fermer l'aide", 1, IntraFont.color(0,0,0,255),IntraFont.color(0,0,0,0))	
			Gu.end3d()
			
			screen.waitVblankStart()
			screen:flip()
		end
		if (pad:circle() and not oldpad:circle()) then
			fin_aide = true
		end
		oldpad = pad
	end
	
	IntraFont.load("flash0:/font/ltn12.pgf", 1)
	fin_aide, bg_aide = nil
end

--------------- ! Fonction pour la fin du jeu ! ---------------
function game_over()
	img_go = Image.load("images/autres/go.png")
	rafraichir = true
	oldpad = Controls.read()
	fin_game = false
	while fin_game == false do
		pad = Controls.read()
		if (rafraichir == true) then
			rafraichir = false
			screen:blit(0,0,img_go)
			screen.waitVblankStart()
			screen:flip()
		end
		if (pad:cross()or pad:circle()or pad:triangle()or pad:start()or pad:select()or pad:l()or pad:r()or pad:square()) then
			fin_game = true
		end
	end
	img_go, rafraichir, oldpad, fin_game = nil
end



----