------------------------------------------------------------------------------------------------------------------------------------------
	-- ! Fonctions avant le demarrage du jeu (verification, chargement...)  ! --
------------------------------------------------------------------------------------------------------------------------------------------



----------------------------------------- ! Fonction qui permet de lancer les fonctions precedents le jeu ! ------------------------------------------
function demarrage()
	sc = 0
	-- ! On vrifie que tous les Drivers sont bien installs ! -- 
	verification_drivers()
	
	-- ! Si ce n'est pas le cas, on les installe (en demandant le consentement du joueur) ! --
	if (drivers_manquants == true) then
		installer_drivers()
	end
end

----------------------------------------- ! Fonction qui permet de verifier si on doit installer les drivers ! ------------------------------------------
function verification_drivers()
	drivers_manquants = false -- Variable qui permet de savoir s'il manque un driver
	if (System.doesDirExist("flash1:/LPHMDRIVER") == 0) then
		drivers_manquants = true
	end
	if ((System.doesFileExist("flash1:/LPHMDRIVER/syslib.prx") == 0) and (drivers_manquants == false)) then
		drivers_manquants = true
	end
	if ((System.doesFileExist("flash1:/LPHMDRIVER/rdriver.prx") == 0)  and (drivers_manquants == false)) then
		drivers_manquants = true
	end
	
	if ((System.doesFileExist("flash1:/LPHMDRIVER/hook.prx") == 0) and (drivers_manquants == false)) then
		drivers_manquants = true
	end
	
	if ((System.doesFileExist("ms0:/seplugins/load.pbp") == 0) and (drivers_manquants == false)) then
		drivers_manquants = true
	end
end

----------------------------------------- ! Fonction qui permet d'installer les drivers ! ------------------------------------------
function installer_drivers()
	-- Cration des variables
	fond_drivers = Image.load("images/installation_drivers.png")
	IntraFont.init()
	noir = IntraFont.color(0,0,0,255)
	blanc = IntraFont.color(255,255,255,255)
	choix_utilisateur = false
	
	-- Tant que l'utilisateur n'a pas choisi --
	while choix_utilisateur == false do
		pad = Controls.read()
		
		-- ! On affiche l'avertissement
		screen:clear()
		screen:blit(0,0,fond_drivers)
		Gu.start3d()
		IntraFont.load("flash0:/font/ltn5.pgf", 1)
		IntraFont.print(10, 25,"\"Il manque actuellement des pilotes pour utiliser", 1, IntraFont.color(255,0,0,255), blanc)
		IntraFont.print(10, 45,"toutes les fonctions du Lua Player HM 8.1\" ", 1, IntraFont.color(255,0,0,255), blanc)
		IntraFont.load("flash0:/font/ltn12.pgf", 1)
		IntraFont.print(10, 70,"- Si vous ne les installez pas, il se peut que vous rencontriez", 1, noir, blanc)
		IntraFont.print(10, 85,"    des problmes lors de l'utilisation de ce jeu.", 1, noir, blanc)
		IntraFont.print(10, 105,"- L'installation de ces pilotes n'est pas necessaires.", 1, noir, blanc)
		IntraFont.print(10, 125,"- Ces pilotes sont installs dans le Flash1 de la PSP, il n'y a aucun", 1, noir, blanc)
		IntraFont.print(10, 140,"    risque de brick.", 1, noir, blanc)
		IntraFont.load("flash0:/font/ltn5.pgf", 1)
		IntraFont.print(10, 200,"Appuyer sur Croix pour installer les pilotes", 1, noir, blanc)
		IntraFont.print(10, 225,"Appuyer sur Rond pour ne pas les installer", 1, noir, blanc)
		Gu.end3d()
		screen:flip()
		
		-- S'il refuse de les installer
		if (pad:circle()) then
			installer = false
			choix_utilisateur = true
		elseif (pad:cross()) then
			installer = true
			choix_utilisateur = true
		end
	end
	IntraFont.term()
	
	-- ! Si l'utilisateur veut installer les drivers ! --
	if (installer == true) then
		-- On redemande confirmation
		System.message("Etes-vous sur de vouloir continuer l'installation des drivers?",1)
		-- Si oui, on installe les drivers
		if (System.buttonPressed(0) == 1) then
			repertoire_courant = System.currentDirectory()
			if (System.doesDirExist("flash1:/LPHMDRIVER") == 0) then
				System.createDirectory("flash1:/LPHMDRIVER")
			end
			System.copyFile(repertoire_courant.."/drivers/hook.prx","flash1:/LPHMDRIVER/hook.prx",0)
			System.copyFile(repertoire_courant.."/drivers/load.pbp","ms0:/seplugins/load.pbp",0)
			System.copyFile(repertoire_courant.."/drivers/rdriver.prx","flash1:/LPHMDRIVER/rdriver.prx",0)
			System.copyFile(repertoire_courant.."/drivers/syslib.prx","flash1:/LPHMDRIVER/syslib.prx",0)
			System.message("L'installation est terminee.",0)
		-- Si non, on reaffiche l'cran precedent
		else
			installer,repertoire_courant,pad,fond_drivers,blanc,choix_utilisateur,drivers_manquants = nil
			installer_drivers()
		end
	-- ! Si l'utilisateur ne veut pas install les drivers ! --
	else
		-- On demande confirmation
		System.message("Etes-vous sur de ne pas vouloir installer les drivers?",1)
		if (System.buttonPressed(0) ~= 1) then
			installer,repertoire_courant,pad,fond_drivers,blanc,choix_utilisateur,drivers_manquants = nil
			installer_drivers()
		end
	end
	
	-- ! On supprime les variables ! --
	installer,repertoire_courant,pad,fond_drivers,blanc,choix_utilisateur,drivers_manquants = nil
end

------------------------------------------ ! Fonction qui permet l'intro du jeu ! ------------------------------------------
function introduction()
	-- Etape 1 : On charge les variables --
	Mp3me.stop() -- On arrete la lecture des sons
	Mp3me.load("sons/son_intro.mp3") -- On charge la musique d'introduction

	-- Etape 2 : On cre le masque pour le fondu blanc--
	masque = Image.createEmpty(480,272) -- on cre un masque de fondu
	opacite = 255 -- on initialise l'opacit  255
	masque:clear(Color.new(0,0,0,opacite)) -- on initialise l'cran  cette opaque

	-- Etape 3 : La fonction s'xecute --
	Mp3me.play() -- On lance la lecture de la piste
	background = Image.load("images/logo.png") -- On charge l'image de fond
	for i = 1,2 do
	
		while (opacite > -3) do
			screen:clear() -- on efface l'cran
			screen:blit(0,0,background) -- on affiche l'image de fond
			screen:blit(0,0,masque) -- on applique le masque de opaque
			opacite = opacite - 3
			masque:clear(Color.new(0,0,0,opacite))
			screen.waitVblankStart()
			screen.flip()
		end
		screen.waitVblankStart()
		while (opacite < 258) do
			screen:clear()
			screen:blit(0,0,background) -- on affiche l'image de fond
			screen:blit(0,0,masque) -- on applique le masque de opaque
			opacite = opacite + 3
			masque:clear(Color.new(0,0,0,opacite))
			screen.waitVblankStart()
			screen.flip()
		end
		background = Image.load("images/presentation.png")
	end
	
	-- Etape 4 : Destruction des variables pour liberer la ram
	background,masque,opacite = nil
end