----------------------------------------------------------------------------------------------------------------------------------------

	-- Fonctions pour la gestion des cartes (Edition, suppression...) --

----------------------------------------------------------------------------------------------------------------------------------------


--------------- ! Permet de recomposer la carte pour avoir un aperu ! ---------------
function generer_apercu(nb)
	i = 0
	id_rang = 0
	-- ! On cherche o se trouve la map dans le tableau ! --
	while (i < table.getn(cartes) and (id_rang == 0)) do
		i = i + 1
		if (cartes[i].num == nb) then
			id_rang = i
		end
	end
	
	-- ! On dcompose la chaine de caractres dans un tableau ! --
	apercu = {}
	for i = 1,string.len(cartes[id_rang].carte) do
		if (tonumber(string.sub(cartes[id_rang].carte,i,i)) == 0) then
			apercu[table.getn(apercu)+1] = 0
		else
			apercu[table.getn(apercu)+1] = 1
		end
	end
end

--------------- ! Permet de changer la place d'une carte parmi les autres ! ---------------
function redefinir_rang()
	-- ! Si la carte se trouve avant son prochain rang (Ex : on insere la carte 1 avant la 6) ! --
	if (num_map < nouveau_num) then
		-- ! Changement d'indice pour les evenements ! --
		for i = 1,table.getn(evenements) do
			-- Si l'evenement est li  la carte modifie ! --
			if (evenements[i].num_carte == num_map) then
				evenements[i].num_carte = nouveau_num
			-- Si la carte se trouve entre l'ancien rang, et le nouveau rang de la carte ! --
			elseif (evenements[i].num_carte > num_map) and (evenements[i].num_carte <= nouveau_num) then
				evenements[i].num_carte = evenements[i].num_carte - 1
			end
		end
		-- ! On trie le tableau par ordre croissant, selon le numero de la carte auxquels sont lis les evenements !--
		trier_evemenents()
		
		-- ! Changement de rang de la carte ! --
		tab_temp = cartes[num_map] -- On mmorise la carte dans un tableau temporaire
		-- ! On dcale les cartes d'un rang precedent ! --
		for i = num_map, nouveau_num - 1 do
			cartes[i] = cartes[i+1]
			cartes[i].num = i -- on change le numero de la carte (pour garder l'enchainement des cartes)
		end
		-- ! On place la carte  son nouveau rang ! --
		cartes[nouveau_num] = tab_temp
		cartes[nouveau_num].num = nouveau_num
		
	-- ! Si la carte se trouve aprs son prochain rang (Ex : on insere la carte 6 avant la 2) ! --
	elseif (num_map > nouveau_num) then
		-- ! Changement d'indice pour les evenements ! --
		for i = 1,table.getn(evenements) do
			-- Si l'evenement est li  la carte modifie ! --
			if (evenements[i].num_carte == num_map) then
				evenements[i].num_carte = nouveau_num
			-- Si la carte se trouve entre l'ancien rang, et le nouveau rang de la carte ! --
			elseif (evenements[i].num_carte < num_map) and (evenements[i].num_carte >= nouveau_num) then
				evenements[i].num_carte = evenements[i].num_carte + 1
			end
		end
		-- ! On trie le tableau par ordre croissant, selon le numero de la carte auxquels sont lis les evenements !--
		trier_evemenents()
		
		-- ! Changement de rang de la carte ! --
		tab_temp = cartes[num_map]
		-- ! On dcale les cartes d'un rang suivant ! --
		for i = num_map, nouveau_num + 1, -1 do
			cartes[i] = cartes[i-1]
			cartes[i].num = i
		end
		-- ! On place la carte  son nouveau rang ! --
		cartes[nouveau_num] = tab_temp
		cartes[nouveau_num].num = nouveau_num
	end
end

--------------- ! Permet de sauvegarder ! ---------------
function creation_sauvegarde()
	-- ! On cre un tableau qui contiendra les cartes ! --
	sauvegarde = {}
	-- ! On liste les cartes ! --
	for i = 1,table.getn(cartes) do
		sauvegarde[table.getn(sauvegarde) + 1] = cartes[i].num
		sauvegarde[table.getn(sauvegarde) + 1] = cartes[i].carte
		sauvegarde[table.getn(sauvegarde) + 1] = cartes[i].c
		sauvegarde[table.getn(sauvegarde) + 1] = cartes[i].l
		sauvegarde[table.getn(sauvegarde) + 1] = cartes[i].tps
		sauvegarde[table.getn(sauvegarde) + 1] = cartes[i].rec
		sauvegarde[table.getn(sauvegarde) + 1] = cartes[i].med
	end
	-- ! On sauvegarde dans un fichier texte ! -- 
	file = io.open("ms0:/PSP/GAME/cale/carte.txt","w")
	for i = 1,table.getn(sauvegarde) do
		file:write(sauvegarde[i].."\n")
	end
	-- ! On crit la balise de fin ! --
	file:write("fin")
	file:close()
	
	-- ! On cre un tableau qui contiendra les evenements ! --
	sauvegarde = nil
	sauvegarde = {}
	-- ! On liste les evenements ! --
	for i = 1,table.getn(evenements) do
		sauvegarde[table.getn(sauvegarde) + 1] = evenements[i].num_carte
		sauvegarde[table.getn(sauvegarde) + 1] = evenements[i].action
		sauvegarde[table.getn(sauvegarde) + 1] = evenements[i].col
		sauvegarde[table.getn(sauvegarde) + 1] = evenements[i].lig
		sauvegarde[table.getn(sauvegarde) + 1] = evenements[i].t_c
		sauvegarde[table.getn(sauvegarde) + 1] = evenements[i].t_l
		sauvegarde[table.getn(sauvegarde) + 1] = evenements[i].img
		sauvegarde[table.getn(sauvegarde) + 1] = evenements[i].couleur
	end
	-- ! On sauvegarde dans un fichier texte ! -- 
	file = io.open("ms0:/PSP/GAME/cale/evenements.txt","w")
	for i = 1,table.getn(sauvegarde) do
		file:write(sauvegarde[i].."\n")
	end
	-- ! On crit la balise de fin ! --
	file:write("fin")
	file:close()
end

--------------- ! Permet de trier les evenements ! ---------------
function trier_evemenents()
	-- ! temp contiendra l'evenement qu'on veut ranger ! --
	temp = {}	  
	-- ! On liste toutes les entres  partir du rang 2 ! --
	for i = 2, table.getn(evenements) do
		-- ! On mmorise la valeur pour la comparaison ! --
		nb = evenements[i].num_carte
		j = i
		-- Tant qu'on est pas au rang 1, et que la valeur precedente est plus grande que celle actuelle ! --
		while (j > 1) and (evenements[j - 1].num_carte > nb) do
			-- ! On place l'venement avant le prcedent ! --
			temp = evenements[j]
			evenements[j] = evenements[j - 1]
			evenements[j - 1] = temp
			j = j - 1
		end
	end
end

--------------- ! Permet de trier les cartes ! ---------------
function trier_cartes()
	temp = {}	  
	-- ! On liste toutes les entres  partir du rang 2 ! --
	for i = 2, table.getn(cartes) do
		-- ! On mmorise la valeur pour la comparaison ! --
		nb = cartes[i].num
		j = i
		-- Tant qu'on est pas au rang 1, et que la valeur precedente est plus grande que celle actuelle ! --
		while (j > 1) and (cartes[j - 1].num > nb) do
			-- ! On place la carte avant le prcedent ! --
			temp = cartes[j]
			cartes[j] = cartes[j - 1]
			cartes[j - 1] = temp
			j = j - 1
		end
	end
end

--------------- ! Permet de confirmer la suppression d'une carte ! ---------------
function supprimer_carte()
	choix_suppression = 0
	selecteur_suppression = false
	rafraichir = true
	oldpad = Controls.read()
	while (choix_suppression == 0) do
		pad = Controls.read()
		if (rafraichir == true) then
			rafraichir = false
			afficher_apercu()
			screen:blit(0,0,masque)
			Gu.start3d()
				IntraFont.print((240 - ((IntraFont.print(240,110,"Voulez-vous vraiment supprimer cette carte?",1,0,0) - 240)/2)),110,"Voulez-vous vraiment supprimer cette carte?",1, IntraFont.color(0,0,0,255), IntraFont.color(255,255,255,255))
			if (selecteur_suppression == true) then
				IntraFont.print(200,160,"Oui",1,IntraFont.color(255,255,255,255),IntraFont.color(0,0,255,255))
				IntraFont.print(250,160,"Non",1,IntraFont.color(0,0,0,255),IntraFont.color(255,255,255,255))
			else
				IntraFont.print(200,160,"Oui",1,IntraFont.color(0,0,0,255),IntraFont.color(255,255,255,255))
				IntraFont.print(250,160,"Non",1,IntraFont.color(255,255,255,255),IntraFont.color(0,0,255,255))
			end
			Gu.end3d()
			screen.waitVblankStart()
			screen:flip()
		end
		if ((pad:right() and not oldpad:right()) or (pad:left() and not oldpad:left())) then
			if (selecteur_suppression == true) then
				selecteur_suppression = false
			else
				selecteur_suppression = true
			end
			rafraichir = true
		elseif (pad:cross() and not oldpad:cross()) then
			choix_suppression = selecteur_suppression
		end
		oldpad = pad
	end
	if (choix_suppression == false) then
		navigation = true
		rafraichir = true
	else
		suppression_carte()
		creation_sauvegarde()
		if (table.getn(cartes) > 0) then
			navigation = true
			generer_apercu(num_map)
			nouveau_num = num_map
			rafraichir = true
		else
			menu_principal()
		end
	end
end

--------------- ! Permet de supprimer la carte ! ---------------
function suppression_carte()
	-- Suppression de la carte -- 
	for i = num_map, table.getn(cartes) - 1 do
		cartes[i] = cartes[i + 1]
		cartes[i].num = i
	end
	cartes[table.getn(cartes)] = nil
	
	temp = {}
	for i = 1,table.getn(evenements) do
		if (evenements[i].num_carte ~= num_map) then
			temp[table.getn(temp)+1] = evenements[i]
			if (temp[table.getn(temp)].num_carte > num_map) then
				temp[table.getn(temp)].num_carte = temp[table.getn(temp)].num_carte - 1
			end
		end
	end
	evenements = temp
	trier_evemenents()
	if (num_map > table.getn(cartes)) then
		num_map = table.getn(cartes)
	end
end

--------------- ! Permet de charger une carte que l'on va modifi ! ---------------
function pre_edition()
	charger_cartes()
	charger_evenements()
	map_en_edition = true
	num_carte = num_map
	nb_colonnes = cartes[num_map].c
	nb_lignes = cartes[num_map].l
	lignes = 2
	colonnes = 2
	meilleur_temps = cartes[num_map].tps
	tab_map = {}
	background = Image.load("images/initialisation.png")
	
	
	-- ! Tableau contenant les libells des evenements possibles ! --
	tab_choix_event = {}
	tab_choix_event[table.getn(tab_choix_event) + 1] = {lib = "Dfinir le dpart" ; desc = "Tinw commencera le niveau sur cette case." ; actif = true}
	tab_choix_event[table.getn(tab_choix_event) + 1] = {lib = "Dfinir l'arrive" ; desc = "Tinw devra arriver  cette case pour changer de niveau." ; actif = true}
	tab_choix_event[table.getn(tab_choix_event) + 1] = {lib = "Crer un tlporteur" ; desc = "Permet de transporter Tinw sur une autre case." ; actif = true}
	tab_choix_event[table.getn(tab_choix_event) + 1] = {lib = "Retour au menu principal" ; desc = "Ne sauvegarde pas la carte en cours" ; actif = true}
	tab_choix_event[table.getn(tab_choix_event) + 1] = {lib = "Ne rien faire" ; desc = "Retourner au trac de la carte." ; actif = true}
	
	
	for i = 1,string.len(cartes[num_map].carte) do
		if (tonumber(string.sub(cartes[num_map].carte,i,i)) == 0) then
			tab_map[table.getn(tab_map)+1] = 0
		else
			tab_map[table.getn(tab_map)+1] = 1
		end
	end
	event = {}
	for i = 1,nb_lignes do
		for j = 1,nb_colonnes do
			k = 0
			evenement_trouve = false
			while (k < table.getn(evenements) and evenement_trouve == false) do
				k = k + 1
				if ((evenements[k].num_carte == num_map) and (evenements[k].col == j) and (evenements[k].lig == i)) then
					evenement_trouve = true
					event[table.getn(event)+1] = evenements[k]
					if (evenements[k].action == "depart") then
						tab_map[(i-1)*nb_colonnes + j] = 2
						tab_choix_event[1].actif = false
						lignes = i
						colonnes = j
						--event[table.getn(event)].action = "depart"
					elseif (evenements[k].action == "arrivee") then
						tab_map[(i-1)*nb_colonnes + j] = 3
						tab_choix_event[2].actif = false
						--event[table.getn(event)].action = "arrivee"
					elseif (evenements[k].action == "teleport") then
						tab_map[(i-1)*nb_colonnes + j] = 4
						--event[table.getn(event)].action = "teleport"
					end
				end
			end
		end
	end
	trier_tableau()

	case = (lignes-1)*nb_colonnes + colonnes
end
---