----------------------------------------------------------------------------------------------------------------------------------------

	-- Fonctions pour le graphisme --

----------------------------------------------------------------------------------------------------------------------------------------



--------------- ! Affichage durant le parametrage de la nouvelle carte (nb lignes...) ! ---------------
function afficher_initialisation()
	rafraichir = false
	Gu.start3d()
		IntraFont.load("flash0:/font/ltn5.pgf", 1)
		-- ! Affichage du numro de la carte ! --
		if (valider_num_carte == false) then
			IntraFont.print(20,130,"Vous allez raliser la map numro : ",1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
			taille = IntraFont.print(20,130,"Vous allez raliser la map numro : ",1, 0,0)
		-- ! Choix du nombre de colonnes ! --
		elseif (nb_colonnes == 0) then
			IntraFont.print(20,130,"Saisissez le nombre de colonnes : ",1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
			taille = IntraFont.print(20,130,"Saisissez le nombre de colonnes : ",1, 0,0)
		-- ! Choix du nomvre de lignes ! --
		elseif (nb_lignes == 0) then
			IntraFont.print(20,130,"Saisissez le nombre de lignes : ",1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
			taille = IntraFont.print(20,130,"Saisissez le nombre de lignes : ",1, 0,0)
		end
		IntraFont.print(100,240,"Appuyez sur Croix pour valider",1, IntraFont.color(0,0,0,255), IntraFont.color(255,255,255,255))
		IntraFont.load("flash0:/font/ltn4.pgf", 1)
		-- ! Affichage de la valeur ! --
		IntraFont.print(taille + 10, 130, num_clavier,2,IntraFont.color(233,56,63,255), 0)
	Gu.end3d()
end

--------------- ! Affichage durant la conception de la carte ! ---------------
function actualiser_ecran()
	-- On cherche sur quel type de case on est
	trouver_type_case()

	rafraichir = false
		
	-- On affiche le cadre pour les infos ! --
	screen:blit(0,-2,cadre_info)
	
	-- ! On affiche la carte ! --
	afficher_carte(1)
	
	-- On affiche les infos ! --
	Gu.start3d()
		IntraFont.load("flash0:/font/ltn9.pgf", 1)
		IntraFont.print(2, 12, "Nb Lignes : "..nb_lignes, 1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
		IntraFont.print(2, 26, "Nb Colonnes : "..nb_colonnes, 1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
		IntraFont.print(160, 12, "Lignes : "..lignes, 1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
		IntraFont.print(160, 26, "Colonnes: "..colonnes, 1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
		IntraFont.print(280, 12, "Case : "..case, 1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
		IntraFont.print(280, 26, "Type : "..type_case, 1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
	Gu.end3d()
end

--------------- ! Affichage pendant le choix de l'venement  ajouter ! ---------------
function afficher_choix_evenement()
	rafraichir = false
	
	-- On affiche le fond ! --
	screen:blit(0,0,background)
		
	-- On affiche le cadre pour les infos ! --
	screen:blit(0,240,cadre_info)
	
	Gu.start3d()
		-- On affiche la phrase gnrale
		IntraFont.load("flash0:/font/ltn4.pgf", 1)
		IntraFont.print(20,30,"Choisissez l'venement  ajouter : ",1, IntraFont.color(255,255,255,255), IntraFont.color(50,50,50,255))
		IntraFont.load("flash0:/font/ltn5.pgf", 1)
		
		-- ! On affiche tous les choix possibles ! --
		pos_y = 60
		for i = 1,table.getn(tab_choix_event) do
			-- ! Si le selecteur est sur ce choix ! -- 
			if (i == ind_event) then
				-- On affiche le libell de l'venement
				IntraFont.print(50,pos_y,tab_choix_event[i].lib,1, IntraFont.color(0,0,255,255), IntraFont.color(255,255,255,255))
				IntraFont.load("flash0:/font/ltn12.pgf", 1)
				-- On affiche la description de l'evenement
				IntraFont.print(20,262,tab_choix_event[i].desc,1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
				IntraFont.load("flash0:/font/ltn5.pgf", 1)
			-- ! Si l'evenement est possible (ex : il ne peut y avoir qu'un point de dpart ! --
			elseif (tab_choix_event[i].actif == true) then
				IntraFont.print(50,pos_y,tab_choix_event[i].lib,1, IntraFont.color(255,255,255,255), IntraFont.color(50,50,50,255))
			-- ! Pour les autres cas ! --
			else
				IntraFont.print(50,pos_y,tab_choix_event[i].lib,1, IntraFont.color(0,0,0,120), IntraFont.color(0,0,0,50))
			end
			pos_y = pos_y + 30
		end
	Gu.end3d()
	
	screen.waitVblankStart()
	screen:flip()
end

--------------- ! Affichage durant le choix de la case d'arrive du tlport ! ---------------
function afficher_carte(var)
	-- ! On cre l'unit de la carte ! --
	if (math.floor(470/nb_colonnes)> math.floor(230/nb_lignes)) then
		unite = math.floor(230/nb_lignes)
	else
		unite = math.floor(470/nb_colonnes)
	end
	
	-- ! On dclare le positionnement de la carte sur l'cran (pour la centrer) ! --
	pos_x = (480 - (nb_colonnes*unite))/2
	pos_y = 32 + (240 - (nb_lignes*unite))/2
	
	-- ! On dessine la carte ligne par ligne, colonne par colonne (case par case)! --
	for j = 1,nb_lignes do
		for i = 1,nb_colonnes do
			
			-- ! Si la case est celle o se trouve le selecteur, on affiche un carr blanc ! --
			if (j == lignes) and (i == colonnes) and (var == 1) then
				screen:fillRect(pos_x,pos_y,unite,unite,Color.new(255,255,255))
			
			-- ! Si on est sur les zones non modifiables (le cadre) ! --
			elseif (j == 1) or (i == 1) or (i == nb_colonnes)  or (j == nb_lignes) then
				screen:fillRect(pos_x,pos_y,unite,unite,Color.new(51,51,131))
				
			-- ! Sinon, on affiche un carr bleu plus fonc que le fond ! --
			else
				if (tab_map[(j-1)*nb_colonnes + i] == 0) then
					screen:fillRect(pos_x,pos_y,unite,unite,Color.new(178,178,255))
				elseif (tab_map[(j-1)*nb_colonnes + i] == 2) then
					screen:fillRect(pos_x,pos_y,unite,unite,Color.new(255,128,128))
				elseif (tab_map[(j-1)*nb_colonnes + i] == 3) then
					screen:fillRect(pos_x,pos_y,unite,unite,Color.new(130,168,84))
				elseif (tab_map[(j-1)*nb_colonnes + i] == 4) then
					screen:fillRect(pos_x,pos_y,unite,unite,Color.new(255,255,150))
				elseif (tab_map[(j-1)*nb_colonnes + i] == "a") then
					screen:fillRect(pos_x,pos_y,unite,unite,Color.new(255,255,255))
				else
					screen:fillRect(pos_x,pos_y,unite,unite,Color.new(110,110,255))
				end
			end
			pos_x = pos_x + unite
		end
		pos_y = pos_y + unite
		pos_x = (480 - (nb_colonnes*unite))/2
	end
end

--------------- ! Affichage de la carte pour la gestion des cartes ! ---------------
function afficher_apercu()

	screen:blit(0,0,background)
	screen:blit(0,-2,cadre_info)
	if (math.floor(470/cartes[id_rang].c)> math.floor(230/cartes[id_rang].l)) then
		unite = math.floor(230/cartes[id_rang].l)
	else
		unite = math.floor(470/cartes[id_rang].c)
	end
	
	-- ! On dclare le positionnement de la carte ! --
	pos_x = (480 - (cartes[id_rang].c*unite))/2
	pos_y = 32 + (240 - (cartes[id_rang].l*unite))/2
	
	-- ! On dessine la carte ligne par ligne, colonne par colonne (case par case)! --
	for j = 1,cartes[id_rang].l do
		for i = 1,cartes[id_rang].c do
			if (j == 1) or (i == 1) or (i == cartes[id_rang].c)  or (j == cartes[id_rang].l) then
				screen:fillRect(pos_x,pos_y,unite,unite,Color.new(51,51,131))
			elseif (apercu[(j-1)*cartes[id_rang].c + i] == 0) then
				screen:fillRect(pos_x,pos_y,unite,unite,Color.new(178,178,255))
			else
				screen:fillRect(pos_x,pos_y,unite,unite,Color.new(255,255,255))
			end
			pos_x = pos_x + unite
		end
		pos_y = pos_y + unite
		pos_x = (480 - (cartes[id_rang].c*unite))/2
	end
	Gu.start3d()
	IntraFont.load("flash0:/font/ltn5.pgf", 1)
	IntraFont.print(20,20,"Carte : "..num_map,1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,255,255))
	Gu.end3d()
end

--------------- ! Affichage des options de gestion ! ---------------
function afficher_option()
	screen:blit(110,10,cadre_gestion)
	Gu.start3d()
	IntraFont.load("flash0:/font/ltn4.pgf", 1)
	IntraFont.print((240 - ((IntraFont.print(240,50,"Options",1,0,0) - 240)/2)),50,"Options",1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
	IntraFont.load("flash0:/font/ltn5.pgf", 1)
	if (selecteur == 1) then
		IntraFont.print(125,120,"Modifier la carte",1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
		IntraFont.print(125,160,"Redfinir son rang : "..nouveau_num,1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,100))
		IntraFont.print(125,200,"Supprimer la carte",1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,100))
	elseif (selecteur == 2) then
		IntraFont.print(125,120,"Modifier la carte",1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,100))
		IntraFont.print(125,160,"Redfinir son rang : "..nouveau_num,1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
		IntraFont.print(125,200,"Supprimer la carte",1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,100))
	else
		IntraFont.print(125,120,"Modifier la carte",1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,100))
		IntraFont.print(125,160,"Redfinir son rang : "..nouveau_num,1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,100))
		IntraFont.print(125,200,"Supprimer la carte",1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
	end
	Gu.end3d()
end
---