----------------------------------------------------------------------------------------------------------------------------------------

	-- Fonctions principales autour desquelles s'articulent les autres fonctions --

----------------------------------------------------------------------------------------------------------------------------------------



--------------- ! Fonction qui permet de parametrer les variables du niveau ! ---------------
function initialisation()
	-- !  Valeurs par dfaut des proprits de la carte ! --
	num_carte = table.getn(cartes) + 1 -- numero de la carte
	valider_num_carte = false
	nb_colonnes = 0 -- nombre de colonnes
	nb_lignes = 0 -- nombre de lignes
	map_en_edition = false -- on signale que c'est une nouvelle carte (utile pour la premire sauvegarde)
	meilleur_temps = 0
	record = 0
	medaille = 1
	
	-- ! Autres Variables ! --
	oldpad = Controls.read()
	background = Image.load("images/initialisation.png") -- Wallpaper
	num_clavier = num_carte -- indice pour le nombre de colonnes ou de lignes
	min_num = 1 -- valeur minimale pour le clavier
	rafraichir = true -- permet l'actualisation de l'cran
	
	-- ! Dmarrage des options d'IntraFont ! --
	IntraFont.init()

	
	-- || ETAPE 1 : On demande  l'utilisateur de configurer les valeurs de la carte (nb de lignes et de colonnes) || --
	
	-- ! Tant que l'utilisateur n'a pas rempli les 3 valeurs pour la carte ! --
	while (valider_num_carte == false or nb_colonnes == 0 or nb_lignes == 0) do
		pad = Controls.read()
		-- ! Si l'cran doit tre actualis ! --
		if (rafraichir == true) then
			screen:blit(0,0,background)
			afficher_initialisation()
			screen.waitVblankStart()
			screen:flip()
		end
		
		-- ! Raction en fonction d'une touche ! --
		action_touche_initialisation()
		
		
		oldpad = pad
	end
	
	-- ! Cloture des options d'IntraFont ! --
	IntraFont.term()
	
	-- || ETAPE 2 : On dclare d'autres variables utilises lors de la conception de la carte || --
	
	-- ! Dclaration de variables utilises par la suite ! --
	lignes = 2 -- position du selecteur
	colonnes = 2
	case = (lignes-1)*nb_colonnes + colonnes -- numero de la case o se situe le selecteur
	
	-- ! Tableau contenant les libells des evenements possibles et leur description! --
	tab_choix_event = {}
	tab_choix_event[table.getn(tab_choix_event) + 1] = {lib = "Dfinir le dpart" ; desc = "Tinw commencera le niveau sur cette case." ; actif = true}
	tab_choix_event[table.getn(tab_choix_event) + 1] = {lib = "Dfinir l'arrive" ; desc = "Tinw devra arriver  cette case pour changer de niveau." ; actif = true}
	tab_choix_event[table.getn(tab_choix_event) + 1] = {lib = "Crer un tlporteur" ; desc = "Permet de transporter Tinw sur une autre case." ; actif = true}
	tab_choix_event[table.getn(tab_choix_event) + 1] = {lib = "Retour au menu principal" ; desc = "Ne sauvegarde pas la carte en cours" ; actif = true}
	tab_choix_event[table.getn(tab_choix_event) + 1] = {lib = "Ne rien faire" ; desc = "Retourner au trac de la carte." ; actif = true}
	
	-- Initialisation du tableau (crant la carte)
	tab_map = {}
	nb_tab = 0
	for i = 1,nb_lignes do
		for j = 1,nb_colonnes do
			nb_tab = nb_tab + 1
			tab_map[nb_tab] = 0
		end
	end
	
	-- Tableau des venements
	event = {}
	
	
	-- || ETAPE 3 : On appelle la fonction principale de l'diteur || --
	-- ! Appel de la fonction principale ! --
	fonction_principale()
end

--------------- ! Fonction qui permet de concevoir la carte ! ---------------
function fonction_principale()
	rafraichir = true -- Variable qui permet l'actualisation de l'cran
	cadre_info = Image.load("images/cadre_info.png") -- Image pour les infos en haut de l'cran
	selecteur_img = Image.load("images/selecteur.png") -- Image pour le selecteur
	oldpad = Controls.read()
	mode = "trace" -- Switch entr le trac et le calcul de la distance.
	
	
	while true do
		pad = Controls.read()
		
		-- ! Si l'cran doit tre actualis ! --
		if (rafraichir == true) then
			-- On affiche le fond ! --
			screen:blit(0,0,background)
			actualiser_ecran()
			screen.waitVblankStart()
			screen:flip()
		end
		
		-- ! Raction en fonction d'une touche ! --
			action_touche()
		
		oldpad = pad
	end
end

--------------- ! Fonction du menu principal (crer une carte ou gerer les cartes) ! ---------------
function menu_principal()
	-- || ETAPE 1 : Cration des variables || --
	background = Image.load("images/menu.png") -- Wallpaper
	choix = 0 -- Valeur par dfaut de la variable du choix de l'action de l'utilisateur
	selecteur = 1 -- Positionnement du selecteur
	rafraichir = true -- Variable qui permet l'actualisation de l'cran
	oldpad = Controls.read()
	
	-- ! Dmarrage des options d'IntraFont ! --
	IntraFont.init()
	
	
	-- || ETAPE 2 : Tant que l'utilisateur n'a pas choisi d'action faire (crer une carte...) || --
	while (choix == 0) do
		pad = Controls.read()
		
		-- ! Si l'cran doit etre actualis ! --
		if (rafraichir == true) then
			rafraichir = false
			screen:blit(0,0,background)
			Gu.start3d()
			IntraFont.load("flash0:/font/ltn5.pgf", 1) -- choix de la police
			
			-- Si le selecteur est sur l'option 1
			if (selecteur == 1) then
				IntraFont.print((240 - ((IntraFont.print(240,200,"Crer une carte",1,0,0) - 240)/2)),210,"Crer une carte", 1,IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
				-- S'il n'y a aucune carte de dj crer, on affiche pas l'option 2
				if (table.getn(cartes) ~= 0) then
					IntraFont.print((240 - ((IntraFont.print(240,225,"Grer les cartes",1,0,0) - 240)/2)),230,"Grer les cartes", 1,IntraFont.color(170,170,170,255), IntraFont.color(0,0,0,255))
					IntraFont.print((240 - ((IntraFont.print(240,250,"Cl [game]",1,0,0) - 240)/2)),250,"Cl [game]", 1,IntraFont.color(170,170,170,255), IntraFont.color(0,0,0,255))
				else
					IntraFont.print((240 - ((IntraFont.print(240,250,"Cl [game]",1,0,0) - 240)/2)),230,"Cl [game]", 1,IntraFont.color(170,170,170,255), IntraFont.color(0,0,0,255))
				
				end
			-- Si on est sur l'option 2
			elseif (selecteur == 2) then
				IntraFont.print((240 - ((IntraFont.print(240,200,"Crer une carte",1,0,0) - 240)/2)),210,"Crer une carte", 1,IntraFont.color(170,170,170,255), IntraFont.color(0,0,0,255))
				IntraFont.print((240 - ((IntraFont.print(240,225,"Grer les cartes",1,0,0) - 240)/2)),230,"Grer les cartes", 1,IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
				IntraFont.print((240 - ((IntraFont.print(240,250,"Cl [game]",1,0,0) - 240)/2)),250,"Cl [game]", 1,IntraFont.color(170,170,170,255), IntraFont.color(0,0,0,255))
			elseif (selecteur == 3) then
				IntraFont.print((240 - ((IntraFont.print(240,200,"Crer une carte",1,0,0) - 240)/2)),210,"Crer une carte", 1,IntraFont.color(170,170,170,255), IntraFont.color(0,0,0,255))
				-- S'il n'y a aucune carte de dj crer, on affiche pas l'option 2
				if (table.getn(cartes) ~= 0) then
					IntraFont.print((240 - ((IntraFont.print(240,225,"Grer les cartes",1,0,0) - 240)/2)),230,"Grer les cartes", 1,IntraFont.color(170,170,170,255), IntraFont.color(0,0,0,255))
					IntraFont.print((240 - ((IntraFont.print(240,250,"Cl [game]",1,0,0) - 240)/2)),250,"Cl [game]", 1,IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
				else
					IntraFont.print((240 - ((IntraFont.print(240,250,"Cl [game]",1,0,0) - 240)/2)),230,"Cl [game]", 1,IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
				
				end
			end
			Gu.end3d()
			screen.waitVblankStart()
			screen:flip()
		end
		
		-- ! Si l'utilisateur appuie sur BAS, et qu'il y a d'autres cartes dj cre ! --
		if (pad:down() and not oldpad:down()) then
			if (selecteur == 1) then
				if (table.getn(cartes) == 0) then
					selecteur = 3
				else
					selecteur = 2
				end
			elseif (selecteur == 2) then
				selecteur = 3
			else
				selecteur = 1
			end
			rafraichir = true
		-- ! Si l'utilisateur appuie sur HAUT, et qu'il y a d'autres cartes dj cre ! --
		elseif (pad:up() and not oldpad:up()) then
			if (selecteur == 1) then
				selecteur = 3
			elseif (selecteur == 2) then
				selecteur = 1
			elseif (selecteur == 3) then
				if (table.getn(cartes) == 0) then
					selecteur = 1
				else
					selecteur = 2
				end
			end
			rafraichir = true
		-- ! Si l'utilisateur appuie sur Croix, on attribue la valeur du selecteur au choix ! --
		elseif (pad:cross() and not oldpad:cross()) then
			choix = selecteur
		end
		
		oldpad = pad
	end
	
	-- ! Cloture des options d'IntraFont ! --
	IntraFont.term()
	
	
	-- || ETAPE 3 : Traitement de la rponse de l'utilisateur || -- 
	if (choix == 1) then -- conception d'une nouvelle carte
		initialisation()
	elseif (choix == 2) then -- gestion des anciennes cartes
		gestion_carte()
	elseif (choix == 3) then
		System.runeboot("ms0:/PSP/GAME/cale/EBOOT.PBP")
	end
end

--------------- ! Fonction du menu de la Gestion des cartes ! ---------------
function gestion_carte()
	-- || ETAPE 1 : Cration des variables || --
	background = Image.load("images/initialisation.png") -- Wallpaper
	cadre_info = Image.load("images/cadre_info.png") -- Cadre du haut
	cadre_gestion = Image.load("images/gestion.png") -- cadre pour les options de gestion
	masque = Image.createEmpty(480,272) -- on cre un masque 
	masque:clear(Color.new(255,255,255,160))
	oldpad = Controls.read()
	choix_gestion = 0 -- valeur par dfaut du choix de l'action  effectuer sur la carte
	rafraichir = true -- variable qui permet d'actualiser l'cran
	num_map = 1 -- on se place sur la premire map
	-- ! On appelle une fonction qui va gnrer la carte ! --
	generer_apercu(num_map)
	navigation = true -- variable qui permet de savoir si on change de cartes, ou si on choisit une action  effectuer
	selecteur = 1 -- variable pour le choix de l'action  effectuer
	nouveau_num = num_map -- variable qui permet de choisir un nouveau rang pour la carte
	
	-- ! Dmarrage des options d'IntraFont ! --
	IntraFont.init()
	
	
	-- || ETAPE 2 : Tant que l'utilisateur n'a pas choisi une action  effectuer sur la carte slectionne ! --
	while (choix_gestion == 0) do
		pad = Controls.read()
		-- ! Si l'cran doit tre actualis ! --
		if (rafraichir == true) then
			rafraichir = false
			-- On affiche un apercu de la carte
			afficher_apercu()
			-- Si on affiche le menu des actions possibles
			if (navigation == false) then
				afficher_option()
			end
			screen.waitVblankStart()
			screen:flip()
		end
		
		-- ! Raction en fonction d'une touche presse ! --
		action_gestion()
		oldpad = pad
	end
	
	-- ! Cloture des options d'IntraFont ! --
	IntraFont.term()
end  

--------------- ! Fonction du menu pause ! ---------------
function menu_pause()
	rafraichir = true
	choix_pause = 0
	oldpad = Controls.read()
	selecteur = 1
	masque_pause = Image.createEmpty(480,272)
	masque_pause:clear(Color.new(0,0,0,200))
	while (choix_pause == 0) do
		pad = Controls.read()
		if (rafraichir == true) then
			-- On cherche sur quel type de case on est
			trouver_type_case()

			rafraichir = false
			
			screen:blit(0,0,background)
			-- On affiche le cadre pour les infos ! --
			screen:blit(0,-2,cadre_info)
			
			-- ! On affiche la carte ! --
			afficher_carte(1)
			-- On affiche les infos ! --
			Gu.start3d()
				IntraFont.load("flash0:/font/ltn9.pgf", 1)
				IntraFont.print(2, 12, "Nb Lignes : "..nb_lignes, 1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
				IntraFont.print(2, 26, "Nb Colonnes : "..nb_colonnes, 1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
				IntraFont.print(160, 12, "Lignes : "..lignes, 1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
				IntraFont.print(160, 26, "Colonnes: "..colonnes, 1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
				IntraFont.print(280, 12, "Case : "..case, 1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
				IntraFont.print(280, 26, "Type : "..type_case, 1, IntraFont.color(255,255,255,255), IntraFont.color(0,0,0,255))
			Gu.end3d()
			screen:blit(0,0,masque_pause)
			Gu.start3d()
			if (selecteur == 1) then
				IntraFont.load("flash0:/font/ltn4.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,190,"Continuer",1,0,0) - 240)/2)),110,"Continuer", 1, IntraFont.color(255,255,255,255), IntraFont.color(100,100,100,255))
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,220,"Sauvegarder",1,0,0) - 240)/2)),140,"Sauvegarder", 1, IntraFont.color(50,50,50,255), IntraFont.color(0,0,0,255))
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,220,"Quitter",1,0,0) - 240)/2)),170,"Quitter", 1, IntraFont.color(50,50,50,255), IntraFont.color(0,0,0,255))
			elseif (selecteur == 2) then
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,190,"Continuer",1,0,0) - 240)/2)),110,"Continuer", 1, IntraFont.color(50,50,50,255), IntraFont.color(0,0,0,255))
				IntraFont.load("flash0:/font/ltn4.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,220,"Sauvegarder",1,0,0) - 240)/2)),140,"Sauvegarder", 1, IntraFont.color(255,255,255,255), IntraFont.color(100,100,100,255))
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,220,"Quitter",1,0,0) - 240)/2)),170,"Quitter", 1, IntraFont.color(50,50,50,255), IntraFont.color(0,0,0,255))
			elseif (selecteur == 3) then
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,190,"Continuer",1,0,0) - 240)/2)),110,"Continuer", 1, IntraFont.color(50,50,50,255),IntraFont.color(0,0,0,255))
				IntraFont.load("flash0:/font/ltn8.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,220,"Sauvegarder",1,0,0) - 240)/2)),140,"Sauvegarder", 1, IntraFont.color(50,50,50,255), IntraFont.color(0,0,0,255))
				IntraFont.load("flash0:/font/ltn4.pgf", 1)
				IntraFont.print((240 - ((IntraFont.print(240,220,"Quitter",1,0,0) - 240)/2)),170,"Quitter", 1, IntraFont.color(255,255,255,255), IntraFont.color(100,100,100,255))
			end
			Gu.end3d()
			screen.waitVblankStart()
			screen:flip()
		end
		
		if (pad:up() and not oldpad:up()) then
			if (selecteur == 3) then
				if (table.getn(event) < 2) then
					selecteur = 1
				elseif (table.getn(event) >= 2) then
					if (event[1].action == "depart") and (event[2].action == "arrivee") then
						selecteur = 2
					else
						selecteur = 1
					end
				end
			elseif (selecteur == 1) then
				selecteur = 3
			else
				selecteur = selecteur - 1
			end
			rafraichir = true
		elseif (pad:down() and not oldpad:down()) then
			if (selecteur == 1)  and (table.getn(event) < 2) then
				if (table.getn(event) < 2) then
					selecteur = 3
				elseif (table.getn(event) >= 2) then
					if (event[1].action == "depart") and (event[2].action == "arrivee") then
						selecteur = 2
					else
						selecteur = 3
					end
				end
			elseif (selecteur == 3) then
				selecteur = 1
			else
				selecteur = selecteur + 1
			end
			rafraichir = true
		elseif (pad:cross() and not oldpad:cross()) then
			choix_pause = selecteur
		end
		oldpad = pad
	end
	IntraFont.load("flash0:/font/ltn12.pgf", 1)
	if (choix_pause == 2) then
		option_sauvegarde()
	elseif (choix_pause == 3) then
		charger_cartes()
		charger_evenements()
		menu_principal()
	end
	rafraichir = true
end

-------